package com.jaywagnon.mymvc.configuration;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

import javax.sql.DataSource;


/**
 * Configuration for the Application context.
 */
@Configuration
@Import(DataSourceConfiguration.class)
@ComponentScan({"com.jaywagnon.mymvc.services"})
public class WebAppConfiguration
{
  /**
   * Configuration and instantiation class for DataSource objects.
   */
  @Autowired
  DataSourceConfiguration dataSourceConfiguration;


  /**
   * Returns a DataSource object.
   *
   * @return
   */
  @Bean(destroyMethod = "close")
  public DataSource dataSource()
  {
    return dataSourceConfiguration.dataSource();
  }
}
