package com.jaywagnon.mymvc.configuration;


import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;
import org.springframework.web.context.ContextLoaderListener;
import org.springframework.web.servlet.DispatcherServlet;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRegistration;

import static org.mockito.Mockito.*;


@RunWith(MockitoJUnitRunner.class)
public class WebAppInitializerTest
{
  @Mock
  private ServletContext servletContext;

  @Mock
  private ServletRegistration.Dynamic dispatcher;


  @Test
  public void test_onStartUp()
          throws ServletException
  {
    WebAppInitializer object = new WebAppInitializer();

    when(servletContext.addServlet(eq("dispatcher"), any(DispatcherServlet.class))).thenReturn(dispatcher);

    object.onStartup(servletContext);

    verify(servletContext).addListener(any(ContextLoaderListener.class));
    verify(servletContext).addServlet(eq("dispatcher"), any(DispatcherServlet.class));
    verify(dispatcher).setLoadOnStartup(eq(1));
    verify(dispatcher).addMapping(eq("/"));
  }
}
