package com.jaywagnon.mymvc.persistence.entities;


import org.junit.Test;

import static junit.framework.TestCase.*;


public class AbstractEntityTest
{
  MockEntity entity = new MockEntity();


  @Test
  public void test_Constructor_default()
  {
    assertNotNull(entity);
  }


  @Test
  public void test_Constructor()
  {
    Long id = new Long(1);
    MockEntity entity = new MockEntity(id);
    assertNotNull(entity);
    assertEquals(id, entity.getId());
  }


  @Test
  public void test_id()
  {
    Long id = new Long(1);
    assertNull(entity.getId());

    entity.setId(id);
    assertEquals(id, entity.getId());
  }


  private class MockEntity
          extends AbstractEntity
  {
    public MockEntity()
    {
    }


    public MockEntity(Long id)
    {
      super(id);
    }
  }
}
